require './common.rb'
require './server.rb'
require './module.rb'

require 'yaml'

module Vrobot4
   def self.loadServer servinfo
      type = servinfo["type"]

      serv = Server::get_server_type(type).new(servinfo)

      servinfo.has_key?("modules") && servinfo["modules"].each \
         {|mod| serv.loadMod Module::get_module_type(mod).new}

      serv
   end

   def self.loadBot botinfo
      servers = []
      botinfo["servers"].each {|servinfo| servers << loadServer(servinfo)}
      {:info => botinfo, :servs => servers}
   end

   def self.runBots bots
      thrds = []
      bots.each do |bot|
         bot[:servs].each {|serv| thrds << Thread.new {serv.connect}}
      end
      thrds.each {|th| th.join}
   end

   def self.main cfgname
      cfg = nil

      log :INFO, "vrobot version", Version

      begin;  cfg = YAML.load IO.read(cfgname)
      rescue; log :ERROR, "error reading bot config:", $!; exit; end

      Vrobot4.debug = cfg["debug"] if cfg.has_key? "debug"

      cfg["loadmods"].each {|mod| load mod, true}

      begin
         bots = []
         cfg["bots"].each {|botinfo| bots << loadBot(botinfo)}
         log :DEBUGV, "bots:", bots.to_s
         runBots bots
      rescue
         log :ERROR, "error loading bot config:", $!
         exit
      end
   end
end

Vrobot4.main "bot.yml"

## EOF
